;******************************************************************************
; PLACA BUGGY 1                                                               *
;                                                                             *
; Remote-controlled toy-car.                                                  *
;                                                                             *
;******************************************************************************
;                                                                             *
; Pin assignments:                                                            *
;   GP0 - light.                                                              *
;   GP1 - left motor.                                                         *
;   GP2 - enable/disable motors.                                              *
;   GP3 - IR receiver.                                                        *
;   GP4 - right motor.                                                        *
;   GP5 - horn.                                                               *
;                                                                             *
;******************************************************************************
;                                                                             *
; Copyright (C) 2012 Sergio García-Cuevas González.                           *
;                                                                             *
; This program is free software; you can redistribute it and/or modify        *
; it under the terms of the GNU General Public License as published by        *
; the Free Software Foundation; either version 3 of the License, or           *
; (at your option) any later version.                                         *
;                                                                             *
; This program is distributed in the hope that it will be useful,             *
; but WITHOUT ANY WARRANTY; without even the implied warranty of              *
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
; GNU General Public License for more details.                                *
;                                                                             *
; You should have received a copy of the GNU General Public License           *
; along with this program.  If not, see <http://www.gnu.org/licenses/>.       *
;                                                                             *
;******************************************************************************

        list      p=12f629
        #include <p12f629.inc>
        #include "asm/config.inc"

;***** CONFIGURATION
; _CPD_OFF:            Off course you can copy data.
; _CP_OFF:             Off course you can copy code.
; _BODEN_ON:           Brown-out detection is enabled.
; _MCLRE_OFF:          Reset button disabled.
; _PWRTE_ON:           Wait 72 ms at power-up for supply-voltage stabilisation.
; _WDT_ON:             Watchdog timer is on.
; _INTRC_OSC_NOCLKOUT: Use internal oscillator.
       __CONFIG  _CPD_OFF & _CP_OFF & _BODEN_ON & _MCLRE_OFF & _PWRTE_ON & _WDT_ON & _INTRC_OSC_NOCLKOUT


        EXTERN  configure_io,init_variables,configure_timer,configure_interrupts,main_loop
        GLOBAL  main

RESET   CODE    h'0000'
        ORG     000H            ; Address 000H, reset vector.
        GOTO    main

MAIN    CODE
main
        CALL    configure_io    ; Configure input and output lines.
        CALL    init_variables  ; Initialise the variables.
        CALL    configure_timer ; Configure the clock.
        CALL    configure_interrupts ; Enable the interrupts.
        GOTO    main_loop       ; Enter the main loop.
        END
