;******************************************************************************
;                                                                             *
; Copyright (C) 2012 Sergio García-Cuevas González.                           *
;                                                                             *
; This program is free software; you can redistribute it and/or modify        *
; it under the terms of the GNU General Public License as published by        *
; the Free Software Foundation; either version 3 of the License, or           *
; (at your option) any later version.                                         *
;                                                                             *
; This program is distributed in the hope that it will be useful,             *
; but WITHOUT ANY WARRANTY; without even the implied warranty of              *
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
; GNU General Public License for more details.                                *
;                                                                             *
; You should have received a copy of the GNU General Public License           *
; along with this program.  If not, see <http://www.gnu.org/licenses/>.       *
;                                                                             *
;******************************************************************************

        list      p=12f629
        #include <p12f629.inc>
        #include "asm/config.inc"

        GLOBAL  get_command
        EXTERN  new_cmd,pulses

GET_COMMAND     CODE
; Read the current command.
; 
; Uses:
;   - pulses
;   - W as return value
get_command
        ; Decide the command depending on the number of pulses.
        ; If 0 <= pulses < stop_pulses, stop.
        MOVLW   stop_pulses
        SUBWF   pulses,W
        BTFSS   STATUS,C
        RETLW   1<<stop_cmd
        ; If stop_pulses <= pulses < backward_pulses, go backward.
        MOVLW   backward_pulses
        SUBWF   pulses,W
        BTFSS   STATUS,C
        RETLW   1<<backward_cmd
        ; If backward_pulses <= pulses < forward_pulses, go forward.
        MOVLW   forward_pulses
        SUBWF   pulses,W
        BTFSS   STATUS,C
        RETLW   1<<forward_cmd
        ; If backward_pulses <= pulses < left_pulses, turn left.
        MOVLW   left_pulses
        SUBWF   pulses,W
        BTFSS   STATUS,C
        RETLW   1<<left_cmd
        ; If left_pulses <= pulses < right_pulses, turn right.
        MOVLW   right_pulses
        SUBWF   pulses,W
        BTFSS   STATUS,C
        RETLW   1<<right_cmd
        ; If right_pulses <= pulses < horn_pulses, use the horn.
        MOVLW   horn_pulses
        SUBWF   pulses,W
        BTFSS   STATUS,C
        RETLW   1<<horn_cmd
        ; If horn_pulses <= pulses, switch on the light.
        RETLW   1<<light_cmd
 
        END
