;******************************************************************************
;                                                                             *
; Copyright (C) 2012 Sergio García-Cuevas González.                           *
;                                                                             *
; This program is free software; you can redistribute it and/or modify        *
; it under the terms of the GNU General Public License as published by        *
; the Free Software Foundation; either version 3 of the License, or           *
; (at your option) any later version.                                         *
;                                                                             *
; This program is distributed in the hope that it will be useful,             *
; but WITHOUT ANY WARRANTY; without even the implied warranty of              *
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
; GNU General Public License for more details.                                *
;                                                                             *
; You should have received a copy of the GNU General Public License           *
; along with this program.  If not, see <http://www.gnu.org/licenses/>.       *
;                                                                             *
;******************************************************************************

        list      p=12f629
        #include <p12f629.inc>
        #include "asm/config.inc"

        EXTERN  counter,pulses,new_cmd,apply_command,get_command,state

ISR_UDATA UDATA_SHR
sSTATUS RES     1
sW      RES     1

ISR     CODE    h'0004'
        ORG     004H            ; Address 004H, ISR vector.
        ; Save context.
        MOVWF   sW              ; Store a copy of W.
        MOVF    STATUS,W        ; Store a copy of STATUS.
        MOVWF   sSTATUS
        ; Handle the interrupt.
        BANKSEL INTCON
        BTFSC   INTCON,T0IF     ; If this was a TIMER0 interrupt
        GOTO    timer0_isr      ; then handle it
gpio_isr
        BCF     INTCON,GPIF     ; else this is a GPIO interrupt.
        BTFSC   GPIO,input_pin  ; If input_pin is high
        INCF    counter,F       ; then increment the pulse counter.
        GOTO    finish          ; Finish.
timer0_isr
        BCF     INTCON,T0IF     ; Clear the interrupt flag.
        MOVF    counter,W       ; Save the value of the pulse counter.
        MOVWF   pulses
        CLRF    counter
        BCF     state,seen      ; Mark the reading for processing.
finish
        MOVF    sSTATUS,W       ; Restore the old value of STATUS.
        MOVWF   STATUS
        SWAPF   sW,F            ; Restore the old value of W.
        SWAPF   sW,W
        RETFIE

        END
