/*****************************************************************************
 *                                                                            *
 * Copyright (C) 2012 Sergio García-Cuevas González.                          *
 *                                                                            *
 * This program is free software; you can redistribute it and/or modify       *
 * it under the terms of the GNU General Public License as published by       *
 * the Free Software Foundation; either version 3 of the License, or          *
 * (at your option) any later version.                                        *
 *                                                                            *
 * This program is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 * GNU General Public License for more details.                               *
 *                                                                            *
 * You should have received a copy of the GNU General Public License          *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.      *
 *                                                                            *
 *****************************************************************************/

/* Motor holder for "Placa Buggy 1." */

base_thickness = 5.0;
thickness = 1.5;
hole_separation = 2.54;
span = 10 * hole_separation;
width = 4 * hole_separation;
motor_height = 10.5;
motor_span = 12.5;
hole_radius = 1.0;


union ()
{
  difference ()
  {
    cube (size = [span, width, thickness]);
    union ()
    {
      translate (v = [hole_separation, hole_separation, 0])
      {
        cylinder (r = hole_radius, h = thickness);
      }
      translate (v = [hole_separation, 3 * hole_separation, 0])
      {
        cylinder (r = hole_radius, h = thickness);
      }
      translate (v = [span - hole_separation, hole_separation, 0])
      {
        cylinder (r = hole_radius, h = thickness);
      }
      translate (v = [span - hole_separation, 3 * hole_separation, 0])
      {
        cylinder (r = hole_radius, h = thickness);
      }
    }
  }
  difference ()
  {
    translate (v = [span / 2 - motor_span / 2 - thickness, 0, 0])
    {
      cube (size = [2 * thickness + motor_span, width, motor_height + base_thickness + thickness]);
    }
    translate (v = [span / 2 - motor_span / 2, 0, base_thickness])
    {
      cube (size = [motor_span, width, motor_height]);
    }
  }
}
